//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                RedHawk                                   |
//|                              Version 1.00                                |
//|                                                                          |
//|    Tribute to the tremendous work of the blind artist George Redhawk.    |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2016                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-16-2016 (MM-DD-YYYY)            |
//|                        Last revised : 10-18-2016 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#include <windows.h>
#include <WinBase.h>
#include <Shlwapi.h>
#include <time.h>
#include <locale.h>

#pragma warning(disable: 4996) // remove Unsafe notifications
#pragma warning(disable: 4312) // remove warning C4312: 'type cast': conversion from 'long' to 'HMENU' of greater size

#include "Tools.h"

#pragma comment(lib, "..\\GDImage64.lib")
#pragma comment(lib, "..\\WinLIFT64.lib")

// Enable tooltip
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

#define IDI_ICON1     101

#define CTRL_WIDTH    606
#define CTRL_HEIGHT   512
#define CLIENT_WIDTH  608
#define CLIENT_HEIGHT 573

#define IDC_CTRL      -1
#define IDC_TIMER     -2
#define IDC_CLOSE     1
#define IDC_PREV      2
#define IDC_NEXT      3
#define IDC_TASKBAR   4

#define ID_IMAGE      1
#define ID_SIGNATURE  2

struct PROP {
    HWND hMain;
    HWND hCtrl;
    HWND hList;
    DWORD ImageDelay;
    DWORD ImageTick;
    WCHAR szfolder[MAX_PATH];
} ;

PROP gP;

void UseThisImage() {
    gP.ImageTick = 0; gP.ImageDelay = 0;
    long x = 0, y = 0, w = 0, h = 0, nCount = 0;
    HBITMAP hBitmap = 0;
    WCHAR szFile[MAX_PATH];

    wcscpy_s(szFile, List_GetText(gP.hList, List_GetCursel(gP.hList)));
    //PathCombine(szFile, EXEpath(), L"NewOne.png");

    if (ZI_IsPNGanimation(szFile)) { // This is a GDImage PNG animation
        ANIHEADER anih = { 0 };
        hBitmap = ZI_LoadPNGanimation(szFile, anih);
        nCount = anih.nFrame;
        gP.ImageDelay = anih.nSpeed;
        w = anih.nWidth; h = anih.nHeight;
    } else {
        hBitmap = ZI_CreateBitmapFromFile(szFile, w, h);
        nCount = w / h; if ((nCount *  h) != w) { nCount = 1; } else { w = h; }
        if (nCount < 4) {
            gP.ImageDelay = 75;
        } else if (nCount < 8) {
            gP.ImageDelay = 50;
        } else if (nCount < 12) {
            gP.ImageDelay = 37;
        } else {
            gP.ImageDelay = 30;
        }
        w = h;
    }
    x = (CTRL_WIDTH - w) / 2;
    y = (CTRL_HEIGHT - h) / 2;
    ZD_DrawBitmapToCtrl(gP.hCtrl, x, y, hBitmap, ZD_ColorARGB(255, 0), ID_IMAGE, ZS_VISIBLE);
    ZD_SetObjectFrameCount(ID_IMAGE, (BYTE) nCount);    // Save the frame count
    ZD_SetObjectFrameToUse(ID_IMAGE, 1, FALSE);  // Start with frame 1
    ZD_SetObjectHidden(ID_IMAGE, ZS_INACTIVE);   // Disable it

    ZD_SetObjectAlpha(ID_SIGNATURE, 255, FALSE);
}

void Animate() {
    BYTE nAlpha = ZD_GetObjectAlpha(ID_SIGNATURE);
    if (nAlpha > 0) { ZD_SetObjectAlpha(ID_SIGNATURE, nAlpha - 1, FALSE); }

    nAlpha = ZD_GetObjectAlpha(ID_IMAGE);
    if (nAlpha < 255) { ZD_SetObjectAlpha(ID_IMAGE, nAlpha + 1, FALSE); }

    DWORD nTickCount = GetTickCount();
    if (gP.ImageTick == 0) { gP.ImageTick = nTickCount + gP.ImageDelay; }
    if (nTickCount > gP.ImageTick) {
        gP.ImageTick = 0;
        long nFrame = ZD_GetObjectFrameToUse(ID_IMAGE) + 1;
        if (nFrame > ZD_GetObjectFrameCount(ID_IMAGE)) { nFrame = 1; }
        ZD_SetObjectFrameToUse(ID_IMAGE, nFrame, TRUE);
    }
}

void DetectImage() {
    HANDLE WashFind = 0, hFind = 0;
    long nCount = 0;
    WIN32_FIND_DATA fd = { 0 };
    WCHAR zTmp[MAX_PATH] = { 0 };
    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT + 1];

    if (gP.hList == 0) {
        gP.hList = CreateWindowEx(0, L"LISTBOX", 0, WS_CHILD | LBS_SORT, 0, 0, 0, 0, gP.hMain, 0, zInstance(), NULL);
    } else {
        List_DeleteAll(gP.hList);
    }

    PathCombine(gP.szfolder, EXEpath(), L"images\\");
    PathCombine(zTmp, gP.szfolder, L"ani_*.png");
    hFind = FindFirstFile(zTmp, &fd);
    if (hFind != INVALID_HANDLE_VALUE) {
        do {
            wcscpy_s(zTmp, fd.cFileName); CharLower(zTmp);
            _wsplitpath_s(zTmp, drive, dir, fname, ext);
            if (wcslen(ext)) {
                wcsncat_s(ext, L".", 1); CharLower(ext);
                if (wcsstr(L".png.", ext)) {
                    PathCombine(zTmp, gP.szfolder, fd.cFileName);
                    if (List_Add(gP.hList, zTmp) > -1) { nCount += 1; }
                }
            }
        } while (FindNextFile(hFind, &fd) != 0);
        FindClose(hFind);
    }
    if (nCount > 0) {
        List_SelectPlus(gP.hList, 1);
        UseThisImage();
    }

    long x = 0, y = 0, w = 0, h = 0;
    PathCombine(gP.szfolder, EXEpath(), L"resources\\");
    PathCombine(zTmp, gP.szfolder, L"signature.png");
    HBITMAP hBitmap = ZI_CreateBitmapFromFile(zTmp, w, h);
    x = (CTRL_WIDTH - w) / 2;
    y = (CTRL_HEIGHT - h);
    ZD_DrawBitmapToCtrl(gP.hCtrl, x, y, hBitmap, ZD_ColorARGB(255, 0), ID_SIGNATURE, ZS_VISIBLE);
    ZD_SetObjectHidden(ID_SIGNATURE, ZS_INACTIVE); // Don't take focus.
}

void AddChildControls() {
    // Create the GDImage graphic control
    gP.hCtrl = CreateWindowEx(0, L"ZIMAGECTRL", 0, WS_CHILD | WS_VISIBLE, 1, 1, 606, 512, gP.hMain, (HMENU) IDC_CTRL, zInstance(), NULL);
    if (IsWindow(gP.hCtrl)) {
        long UseBackColor = ZD_ARGB(32, 0,100,128); // We use a transparent cyan color for the background.
        ZI_SetProperty(gP.hCtrl, ZI_GradientTop, UseBackColor);
        ZI_SetProperty(gP.hCtrl, ZI_GradientBottom, UseBackColor);
        // Draw as thin border around the border
        //skBorder(gP.hCtrl, 0, 0, 608, 514, 0, 1);
    }

    HWND hCtrl = 0;
    PathCombine(gP.szfolder, EXEpath(), L"resources\\");
    WCHAR zFile[MAX_PATH] = { 0 };
    PathCombine(zFile, gP.szfolder, L"frame.png");
    hCtrl = skStaticImage(gP.hMain, zFile, -2, 0, 612, 576, IDC_TASKBAR);

    PathCombine(zFile, gP.szfolder, L"BTN_Close.png");
    hCtrl = skButtonImage(gP.hMain, zFile, 278, 518, IDC_CLOSE, 0);
    skCreateToolTip(hCtrl, L"Close");

    PathCombine(zFile, gP.szfolder, L"BTN_Left.png");
    hCtrl = skButtonImage(gP.hMain, zFile, 223, 530, IDC_PREV, 0);
    skCreateToolTip(hCtrl, L"Previous");

    PathCombine(zFile, gP.szfolder, L"BTN_Right.png");
    hCtrl = skButtonImage(gP.hMain, zFile, 329, 530, IDC_NEXT, 0);
    skCreateToolTip(hCtrl, L"Next");
}

// Main winproc
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    long nItem, wmId, wmEvent;
    //PAINTSTRUCT ps;
    //HDC hdc;

    switch (uMsg) {
    case WM_CREATE:
         SetTimer(hWnd, IDC_TIMER, 0, 0); // 60 FPS
         break;

    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);
         switch (wmId) {

         case IDC_PREV:
              nItem = List_GetCursel(gP.hList);
              if (nItem > 1) {
                  List_SelectPlus(gP.hList, nItem - 1);
              } else {
                  List_SelectPlus(gP.hList, List_Count(gP.hList));
              }
              UseThisImage();
              break;

         case IDC_NEXT:
              nItem = List_GetCursel(gP.hList);
              if (nItem < List_Count(gP.hList)) {
                  List_SelectPlus(gP.hList, nItem + 1);
              } else {
                  List_SelectPlus(gP.hList, 1);
              }
              UseThisImage();
              break;

         case IDC_CLOSE:
              PostMessage(hWnd, WM_SYSCOMMAND, SC_CLOSE, 0);
              break;
         }
         return 0;

    case WM_TIMER:
         Animate();
         return 0;

    case WM_NCHITTEST:
         return HTCAPTION;

    //case WM_PAINT:
    //     hdc = BeginPaint(hWnd, &ps);
    //     // TODO: process here the WM_PAINT message...
    //     EndPaint(hWnd, &ps);
    //     return 0;

    case WM_DESTROY:
         KillTimer(hWnd, IDC_TIMER);
         PostQuitMessage(0);
         return 0;
    }
   
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}  

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Declaration of local variables
    long nRet = 0, IsInitialized = 0;
    WNDCLASSEX wcx; MSG msg;
    WCHAR zClass[] = L"REDHAWK64";
    WCHAR zTmp[MAX_PATH] = { 0 };

    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    IsInitialized = GetClassInfoEx(hInstance, zClass, &wcx);
    if (!IsInitialized) {
         wcx.style         = CS_HREDRAW | CS_VREDRAW;
         wcx.lpfnWndProc   = WndProc;
         wcx.cbClsExtra    = 0;
         wcx.cbWndExtra    = 0;
         wcx.hInstance     = hInstance;
         wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
         wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
         wcx.hbrBackground = NULL;
         wcx.lpszMenuName  = NULL;
         wcx.lpszClassName = zClass;
         wcx.hIconSm       =  wcx.hIcon;
         if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
     }

     if (IsInitialized) {
         RECT lpr = { 0 };
         DWORD dwExStyle = 0;
         DWORD dwStyle = WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN; // | WS_VISIBLE
         SetRect(&lpr, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT);
         AdjustWindowRectEx(&lpr, dwStyle, FALSE, dwExStyle);
         long w = lpr.right - lpr.left;
         long h = lpr.bottom - lpr.top;
         long x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
         long y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

         gP.hMain = CreateWindowEx(0, zClass, 0, dwStyle, x, y, w, h, NULL, NULL, hInstance, NULL);

         if (gP.hMain) {
            // WARNING, we use a very specific Skin for this application
            // it couldn't be used to skin any regular window.
            PathCombine(gP.szfolder, EXEpath(), L"resources\\");
            PathCombine(zTmp, gP.szfolder, L"RedHawk.sks");
            if (skInitEngine(zTmp, L"")) {
                skSkinWindow(gP.hMain, L"");

                AddChildControls();

                DetectImage();

                ShowWindow(gP.hMain, SW_SHOW);
                SetForegroundWindow(gP.hMain);
                SetFocus(gP.hMain);

                // Main message loop
                while (GetMessage(&msg, NULL, 0, 0)) {
                    TranslateMessage(&msg);
                    DispatchMessage(&msg);
                }
                nRet = (long) msg.wParam;
            }
        }
     }
     return nRet;
}
